function xmCache(){}
var xmigemoCache = {
	loadCache:function(){
		var aFile = Components.classes["@mozilla.org/file/local;1"].createInstance();
		if (aFile instanceof Components.interfaces.nsILocalFile){
		  aFile.initWithPath(
		  	convertCharCodeTo(getPrefValue("xulmigemo.dicpath", "str", ""),"UTF-8")
			);
		  aFile.append("migemocache.txt");
		}
		if(aFile.exists()){
			var cache = readFrom(aFile);
			const UConvID = '@mozilla.org/intl/scriptableunicodeconverter';
			const UConvIF  = Components.interfaces.nsIScriptableUnicodeConverter;
			const UConv = Components.classes[UConvID].getService(UConvIF);
			// sjis  UTF-8 ɕϊ
			UConv.charset = 'Shift_JIS';
			var mygcutf8_str = UConv.ConvertToUnicode(cache);
			this.diskCacheClone = mygcutf8_str;
			return true;
		}
		return false;
	},
	getCacheFor:function (roman){
		//alert(roman);
		var miexp = new RegExp("(^"+sanitize(roman)+"\t.+\n)","im");
		if(this.memCache.match(miexp)){
		//	mydump("use memCache");
			return RegExp.$1.split("	")[1];
		}
		else if(this.diskCacheClone.match(miexp)){
		//	mydump("use diskCacheClone");
			return RegExp.$1.split("	")[1];
		}
		return false;
	},
	saveCache:function (roman,myxp){
		var aFile = Components.classes["@mozilla.org/file/local;1"].createInstance();
		if (aFile instanceof Components.interfaces.nsILocalFile){
			  aFile.initWithPath(
			  	convertCharCodeTo(getPrefValue("xulmigemo.dicpath", "str", ""),"UTF-8")
				);
		  aFile.append("migemocache.txt");
		}
		if(aFile.exists()){
			var cache = readFrom(aFile);
			const UConvID = '@mozilla.org/intl/scriptableunicodeconverter';
			const UConvIF  = Components.interfaces.nsIScriptableUnicodeConverter;
			const UConv = Components.classes[UConvID].getService(UConvIF);
			// sjis  UTF-8 ɕϊ
			UConv.charset = 'Shift_JIS';
			var myutf8_str = UConv.ConvertToUnicode(cache);
			var tmpexp = new RegExp("(^"+sanitize(roman)+"\t.+\n)","im");
			myutf8_str.match(tmpexp);
			var line = RegExp.$1;
			if(line){
				return false
			}
			else{
				UConv.charset = 'Shift_JIS';
				var sjis_str = UConv.ConvertFromUnicode(myutf8_str+roman+"	"+myxp+"\n");
				writeTo(aFile,sjis_str);
				return true;
			}
		}
	},
	memCache:"",
	diskCacheClone:"",
	setMemCache:function(roman,exp){
		var tmpexp = new RegExp("(^"+sanitize(roman)+"\t.+\n)","im");
		if(this.memCache.match(tmpexp)){
			return;
		}
		else{
			this.memCache += roman+"\t"+exp+"\n";
			//mydump(this.memCache);
			return;
		}
	},
	dumpCache:function(){
		if(DEBUG){//fobOɂoȂ@Ђ
			var aFile = Components.classes["@mozilla.org/file/local;1"].createInstance();
			if (aFile instanceof Components.interfaces.nsILocalFile){
				  aFile.initWithPath(
				  	convertCharCodeTo(getPrefValue("xulmigemo.dicpath", "str", ""),"UTF-8")
					);
			  aFile.append("memcachedump.txt");
			}
			else{
				return false;
			}
			if(aFile.exists()){
				var cache = readFrom(aFile);
				const UConvID = '@mozilla.org/intl/scriptableunicodeconverter';
				const UConvIF  = Components.interfaces.nsIScriptableUnicodeConverter;
				const UConv = Components.classes[UConvID].getService(UConvIF);
				UConv.charset = 'Shift_JIS';
				var sjis_str = UConv.ConvertFromUnicode(this.memCache);
				writeTo(aFile,sjis_str);
				return true;
			}else{
				return false;
			}
		}else{
			return false;
		}
	}
}
function xmDic(){}
var xmigemoDicList=new Array();
var xmigemoDic={
	loadDic:function(){// dicPath
		//cconsonant(p:"q")
		var  cList = new Array("","k","s","t","h","m","n","y","r","w","d","z","g","p","b","alph");
		var failed = new Array();
		var file;
		var dicDir = convertCharCodeTo(getPrefValue("xulmigemo.dicpath", "str", ""),"UTF-8");

		const UConvID = '@mozilla.org/intl/scriptableunicodeconverter';
		const UConvIF = Components.interfaces.nsIScriptableUnicodeConverter;
		const UConv   = Components.classes[UConvID].getService(UConvIF);
		// sjis  UTF-8 ɕϊ
		UConv.charset = 'Shift_JIS';

		var i;
		for(i=0;i<cList.length;i++){
			file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			file.initWithPath(dicDir);
			file.append(cList[i]+"a2.txt");
			if(file.exists()){
			//	mydump(cList[i]);
				var cache = readFrom(file);
				var dicstr = UConv.ConvertToUnicode(cache);
				xmigemoDicList[cList[i]]=dicstr;
			}
/*
			else
				xmigemoDicList[cList[i]]='';

			// [U[̓ǂݍ݂ƌ
			file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			file.initWithPath(dicDir);
			file.append(cList[i]+"a2.user.txt");
			if(file.exists()){
				var regexp = new RegExp('', 'm');
				var cache = readFrom(file);
				var dicstr = UConv.ConvertToUnicode(cache);
				dicstr = dicstr.split('\n');
				for (var j in dicstr) {
					dicstr[j] = dicstr[j].split('\t');
					xmigemoDicList[cList[i]].replace(regexp.compile('^('+dicstr[j][0]+')\t', 'm'), dicstr[j].join('\t')+'\t');
					if (RegExp.$1 != dicstr[j][0])
						xmigemoDicList[cList[i]] += dicstr[j].join('\t')+'\n';
				}
			}
*/
		}
	},
	getDic:function(let){
		switch(let){
			case "l":
			case "q":
			case "x":
				return false;//xmigemoDicList["alph"];
			break;
			case "c":
				return xmigemoDicList["t"];//+xmigemoDicList["alph"];
			break;
			case "k":
			case "s":
			case "t":
			case "h":
			case "m":
			case "n":
			case "r":
			case "d":
			case "z":
			case "g":
			case "p":
			case "b":
				return xmigemoDicList[let];//+xmigemoDicList["alph"];
			break;
			case "w":
			case "y":
				return xmigemoDicList[let]+xmigemoDicList[""];//+xmigemoDicList["alph"];
			break;
			case "a":
			case "i":
			case "u":
			case "e":
			case "o":
				return xmigemoDicList[""];//+xmigemoDicList["alph"];
			break;
			case "j":
				return xmigemoDicList["z"];//+xmigemoDicList["alph"];
			break;
			case "f":
				return xmigemoDicList["h"];//+xmigemoDicList["alph"];
			break;
			case "v":
				return xmigemoDicList[""];//+xmigemoDicList["alph"];
			break;
		}
	},
	getAlphaDic:function(){
		return xmigemoDicList["alph"];
	}
}

function readFrom(aFile)
{
   var stream = Components.classes['@mozilla.org/network/file-input-stream;1'].createInstance(Components.interfaces.nsIFileInputStream);
   try {
      stream.init(aFile, 1, 0, false); // open as "read only"

      var scriptableStream = Components.classes['@mozilla.org/scriptableinputstream;1'].createInstance(Components.interfaces.nsIScriptableInputStream);
      scriptableStream.init(stream);

      var fileSize = scriptableStream.available();
      var fileContents = scriptableStream.read(fileSize);

      scriptableStream.close();
      stream.close();

      return fileContents;
   }
   catch(e) {
      return null;
   }
}
function writeTo(aFile, aContent) // nsILocalFile ƁAʂ̕
{
    if (aFile.exists()) aFile.remove(true); // ㏑mF͖BKvΏǉB
    aFile.create(aFile.NORMAL_FILE_TYPE, 0666); // ANZX8iŎwB Win9x Ȃǂł͖B

    var stream = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
    stream.init(aFile, 2, 0x200, false); // open as "write only"

    stream.write(aContent, aContent.length);

    stream.close();

    return aFile;
}