function range2Text(aRange){
	var doc=aRange.startContainer.ownerDocument;
	var scrs=doc.getElementsByTagName("script");
	var trash=doc.createRange();
	var noscrs=doc.getElementsByTagName("noscript");
	if(getPrefValue("javascript.enabled", "bool", "true")=="true"){
		for(var i=0;i<noscrs.length;i++){
			trash.selectNode(noscrs[i]);
			trash.deleteContents();
		}
	}
	var str=new String();
	var tmp = doc.createRange();
	tmp.setStart(aRange.startContainer,aRange.startOffset);
	var tmp2 = doc.createRange();
	var st=aRange.startContainer;
	var en=aRange.endContainer;
	for(var i=0;i<scrs.length;i++){
		if(scrs[i].parentNode.tagName.toUpperCase()=="HEAD"){continue;}
		
		tmp2.selectNode(scrs[i]);
		if(aRange.compareBoundaryPoints(0,tmp2)==-1&&
		tmp2.compareBoundaryPoints(2,aRange)==-1){
		
		tmp.setEndBefore(scrs[i]);
		str+=tmp.toString();
		tmp.selectNode(scrs[i]);
		tmp.collapse(false);
		//tmp.setStartAfter(scrs[i]);ȂG[o
		}
	}

	tmp.setEnd(aRange.endContainer,aRange.endOffset);
	str+=tmp.toString();
	return str;
}
//after:2
//before:4
//just:0
//PRUint16  	 DOCUMENT_POSITION_DISCONNECTED  	= 1
//PRUint16 	DOCUMENT_POSITION_PRECEDING 	= 2
//PRUint16 	DOCUMENT_POSITION_FOLLOWING 	= 4
//PRUint16 	DOCUMENT_POSITION_CONTAINS 	= 8
//PRUint16 	DOCUMENT_POSITION_CONTAINED_BY 	= 16
//PRUint16 	DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC 	= 32
//javascript:alert(document.body.compareDocumentPosition(document.getElementsByTagName("head")[0]))
function body2text(){
	var scrs = document.getElementsByTagName("script");
	var tmp=document.createRange();
	var str="";
	tmp.setStartBefore(document.body);
	for(var i=0;i<scrs.length;i++){
		if(scrs[i].parentNode.tagName.toUpperCase()=="HEAD"){continue;}
		tmp.setEndBefore(scrs[i]);
		str+=tmp.toString();
		tmp.selectNode(scrs[i]);
		tmp.collapse(false);
		//tmp.setStartAfter(scrs[i]);ȂG[o
	}
	tmp.setEndAfter(document.body);
	str+=tmp.toString();
	return str;
	//alert(str);
}
function convertCharCodeFrom(aString, aCharCode){
	var UConvID = "@mozilla.org/intl/scriptableunicodeconverter";
	var UConvIF  = Components.interfaces.nsIScriptableUnicodeConverter;
	var UConv = Components.classes[UConvID].getService(UConvIF);
	
	var tmpString = "";
	try{
		UConv.charset = aCharCode;
		tmpString = UConv.ConvertFromUnicode(aString);
	}catch(e){
		tmpString = null;
	}
	return tmpString;
}

function convertCharCodeTo(aString, aCharCode){
	var UConvID = "@mozilla.org/intl/scriptableunicodeconverter";
	var UConvIF  = Components.interfaces.nsIScriptableUnicodeConverter;
	var UConv = Components.classes[UConvID].getService(UConvIF);
	
	var tmpString = "";
	try{
		UConv.charset = aCharCode;
		tmpString = UConv.ConvertToUnicode(aString);
	}catch(e){
		tmpString = null;
	}
	return tmpString;
}

function hira2kana(aStr){
	var output='';	//the result string
	var c;	//iterates for each of characters in the input
	var n;	//character code (unicode)
	for(var i=0; i<aStr.length;i++)
	{
		c = aStr.charAt(i);
		n = c.charCodeAt(0);
		if((n>=0x3041) && (n<=0x3096))
		{
			c = String.fromCharCode(n+0x60);
		}
		output += c;
	}
	return output;
}


function zenkaku2hankaku(aStr){
//	strz2h
	var output='';	//the result string
	var c;	//iterates for each of characters in the input
	for(var i=0; i<aStr.length;i++)
	{
		c = aStr.charAt(i);
//		n = c.charCodeAt(0);        0xff01-0xff5e
		alert("")
		c = strz2h.getString(c);
		alert("");
		output += c;
	}
	return output;
}
function roman2zen(aStr){
	var output='';	//the result string
	var c;	//iterates for each of characters in the input
	var n;	//character code (unicode)
	for(var i=0; i<aStr.length;i++)
	{
		c = aStr.charAt(i);
		n = c.charCodeAt(0);  //      0xff01-0xff5e
		if((n>=0x21) && (n<=0x7e))
		{
			c = String.fromCharCode(n+0xfee0);
		}
		output += c;
	}
	return output;
}

function katakanav(str){
var r2h=document.getElementById("xmstrings");
	return str.replace(new RegExp(r2h.getString("vu"),"g"),"("+r2h.getString("vu")+"|"+r2h.getString("vuk")+")");
}

function sanitize(str){
//	[]^.+*?$|{}\,^LN^Ԃׂ
str=str.replace(/([\-\:\}\{\|\$\?\*\+\.\^\]\/\[\;\\])/g,"\\$1");
return str;
}

function reverseRegExp(aExp){
	//alert("b");
	var tmp = aExp.source;
	//alert("c");
	tmp=tmp.replace(/\[\]\|/im,"")
			.replace(/\(/g,"{")
			.replace(/\)/g,"(")
			.replace(/\{/g,")");
	tmp = tmp.replace(/\[([^\[]+?)\]/img,"\]$1\[").split("").reverse().join("")
	//alert("d");
	tmp = tmp.replace(/(.)\\/g,"\\$1");
	//alert(tmp);
	//diskDump(tmp);
	return new RegExp(tmp,"im");
}

//htmlToText(by flyson)
function htmlToText(aStr){
    var formatConverter = Components.classes["@mozilla.org/widget/htmlformatconverter;1"]
                                .createInstance(Components.interfaces.nsIFormatConverter);
    var fromStr = Components.classes["@mozilla.org/supports-string;1"]
                                .createInstance(Components.interfaces.nsISupportsString);
    fromStr.data = aStr;
    var toStr = { value: null };

    formatConverter.convert("text/html", fromStr, fromStr.toString().length,
                            "text/unicode", toStr, {});
    toStr = toStr.value.QueryInterface(Components.interfaces.nsISupportsString);
    toStr = toStr.toString();
    return toStr;
}
function htmlToPureText(aStr){
	
}
function convertStrH(){
	//At@xbgȓ͂̂̂Ƃ݂Ȃĕϊ
}
function convertStrR(){
	//At@xbg[}͂̂̂Ƃ݂Ȃĕϊ
}

function convertStr(str){
var r2h=document.getElementById("xmstrings");
var ichi=document.getElementById("xmstrings2");
	//var str;
	var cchar, lastchar, last2char;
	var converted;
	var i;
	converted = lastchar = last2char = "";
	i = 0;
	while (i < str.length) {
		lastchar = last2char = "";
loopcheck:	while (i < str.length) {
			cchar = str.charAt(i++);
			if (isalpha(cchar) && cchar.toUpperCase() == lastchar.toUpperCase()) {
				if (cchar.toUpperCase() == "N") {
					converted += last2char + ichi.getString("n");
					lastchar = cchar = "";
				} else {
					converted += last2char + ichi.getString("ltu");
				}
				last2char = "";
				continue;
			}
			switch (cchar.toUpperCase()) {
				case "A":
				case "I":
				case "U":
				case "E":
				case "O":
					converted += toZen(cchar, lastchar, last2char);
					lastchar = last2char = "";
					break loopcheck;
				case ",":
					if (lastchar.toUpperCase() == "N") lastchar = ichi.getString("n");
					converted += last2char + lastchar + r2h.getString("ten");
					lastchar = last2char = "";
					break loopcheck;
				case ".":
					if (lastchar.toUpperCase() == "N") lastchar = ichi.getString("n");
					converted += last2char + lastchar + r2h.getString("maru");
					lastchar = last2char = "";
					break loopcheck;
				case "-":
					if (lastchar.toUpperCase() == "N") lastchar = ichi.getString("n");
					converted += last2char + lastchar + r2h.getString("border");
					lastchar = last2char = "";
					break loopcheck;
				default:
					if (last2char != "") converted += last2char;
					if (lastchar.toUpperCase() == "N" && cchar.toUpperCase() != "Y") {
						converted += ichi.getString("n");
						lastchar = "";
					}
					break;
			}
			last2char = lastchar;
			lastchar = cchar;
		}
	}
	//if (lastchar.toUpperCase() == "N") lastchar = ichi.getString("n");
	return converted + last2char + lastchar;
}
function toZen(cchar, lastchar, last2char){
var r2h=document.getElementById("xmstrings");
//alert(r2h);
var ichi=document.getElementById("xmstrings2");
//alert(ichi);
	var ulastchar = lastchar.toUpperCase();
	var ulast2char = last2char.toUpperCase();
	switch (cchar.toUpperCase()) {
		case "A":
			if (ulast2char == "B" && ulastchar == "Y") return r2h.getString("bya");
			if (ulast2char == "C" && (ulastchar == "H" || ulastchar == "Y")) return r2h.getString("cha");;
			if (ulast2char == "D" && ulastchar == "H") return r2h.getString("dha");
			if (ulast2char == "D" && ulastchar == "Y") return r2h.getString("dya");
			if (ulast2char == "F" && ulastchar == "Y") return r2h.getString("fya");
			if (ulast2char == "G" && ulastchar == "Y") return r2h.getString("gya");
			if (ulast2char == "H" && ulastchar == "Y") return r2h.getString("hya");
			if (ulast2char == "J" && ulastchar == "Y") return r2h.getString("jya");
			if (ulast2char == "K" && ulastchar == "W") return r2h.getString("kwa");
			if (ulast2char == "K" && ulastchar == "Y") return r2h.getString("kya");
			if ((ulast2char == "L" || ulast2char == "X") && ulastchar == "Y") return r2h.getString("lya");
			if (ulast2char == "M" && ulastchar == "Y") return r2h.getString("mya");
			if (ulast2char == "N" && ulastchar == "Y") return r2h.getString("nya");
			if (ulast2char == "P" && ulastchar == "Y") return r2h.getString("pya");
			if (ulast2char == "R" && ulastchar == "Y") return r2h.getString("rya");
			if (ulast2char == "S" && (ulastchar == "H" || ulastchar == "Y")) return r2h.getString("sha");;
			if (ulast2char == "T" && ulastchar == "H") return r2h.getString("tha");
			if (ulast2char == "T" && ulastchar == "Y") return r2h.getString("cha");
			if (ulast2char == "Z" && ulastchar == "Y") return r2h.getString("ja");
			if (ulastchar == "B") return last2char + r2h.getString("ba");
			if (ulastchar == "D") return last2char + r2h.getString("da");
			if (ulastchar == "F") return last2char + r2h.getString("fa");
			if (ulastchar == "G") return last2char + r2h.getString("ga");
			if (ulastchar == "H") return last2char + r2h.getString("ha");
			if (ulastchar == "J") return last2char + r2h.getString("ja");
			if (ulastchar == "K") return last2char + r2h.getString("ka");
			if (ulastchar == "L" || ulastchar == "X") return last2char + r2h.getString("la");
			if (ulastchar == "M") return last2char + r2h.getString("ma");
			if (ulastchar == "N") return last2char + r2h.getString("na");
			if (ulastchar == "P") return last2char + r2h.getString("pa");
			if (ulastchar == "R") return last2char + r2h.getString("ra");
			if (ulastchar == "S") return last2char + r2h.getString("sa");
			if (ulastchar == "T") return last2char + r2h.getString("ta");
			if (ulastchar == "V") return last2char + r2h.getString("va");
			if (ulastchar == "W") return last2char + r2h.getString("wa");
			if (ulastchar == "Y") return last2char + r2h.getString("ya");
			if (ulastchar == "Z") return last2char + r2h.getString("za");
			return last2char + lastchar + r2h.getString("a");
		case "I":
			if (ulast2char == "B" && ulastchar == "Y") return r2h.getString("byi");
			if (ulast2char == "C" && ulastchar == "H") return r2h.getString("chi");
			if (ulast2char == "C" && ulastchar == "Y") return r2h.getString("cyi");
			if (ulast2char == "D" && ulastchar == "H") return r2h.getString("dhi");
			if (ulast2char == "D" && ulastchar == "Y") return r2h.getString("dyi");
			if (ulast2char == "F" && ulastchar == "Y") return r2h.getString("fi");
			if (ulast2char == "G" && ulastchar == "Y") return r2h.getString("gyi");
			if (ulast2char == "H" && ulastchar == "Y") return r2h.getString("hyi");
			if (ulast2char == "J" && ulastchar == "Y") return r2h.getString("jyi");
			if (ulast2char == "K" && ulastchar == "Y") return r2h.getString("kyi");
			if ((ulast2char == "L" || ulast2char == "X") && ulastchar == "Y") return r2h.getString("li");;
			if (ulast2char == "M" && ulastchar == "Y") return r2h.getString("myi");
			if (ulast2char == "N" && ulastchar == "Y") return r2h.getString("nyi");
			if (ulast2char == "P" && ulastchar == "Y") return r2h.getString("pyi");
			if (ulast2char == "R" && ulastchar == "Y") return r2h.getString("ryi");
			if (ulast2char == "S" && ulastchar == "H") return r2h.getString("si");
			if (ulast2char == "S" && ulastchar == "Y") return r2h.getString("syi");
			if (ulast2char == "T" && ulastchar == "H") return r2h.getString("thi");
			if (ulast2char == "T" && ulastchar == "Y") return r2h.getString("tyi");
			if (ulast2char == "W" && ulastchar == "Y") return r2h.getString("wyi");
			if (ulast2char == "Z" && ulastchar == "Y") return r2h.getString("jyi");
			if (ulastchar == "B") return last2char + r2h.getString("bi");
			if (ulastchar == "D") return last2char + r2h.getString("di");
			if (ulastchar == "F") return last2char + r2h.getString("fi");
			if (ulastchar == "G") return last2char + r2h.getString("gi");
			if (ulastchar == "H") return last2char + r2h.getString("hi");
			if (ulastchar == "J") return last2char + r2h.getString("ji");
			if (ulastchar == "K") return last2char + r2h.getString("ki");
			if (ulastchar == "L" || ulastchar == "X") return last2char + r2h.getString("li");
			if (ulastchar == "M") return last2char + r2h.getString("mi");
			if (ulastchar == "N") return last2char + r2h.getString("ni");
			if (ulastchar == "P") return last2char + r2h.getString("pi");
			if (ulastchar == "R") return last2char + r2h.getString("ri");
			if (ulastchar == "S") return last2char + r2h.getString("si");
			if (ulastchar == "T") return last2char + r2h.getString("ti");
			if (ulastchar == "V") return last2char + r2h.getString("vi");
			if (ulastchar == "W") return last2char + r2h.getString("wi");
			if (ulastchar == "Y") return last2char + r2h.getString("i");
			if (ulastchar == "Z") return last2char + r2h.getString("ji");
			return last2char + lastchar + r2h.getString("i");
		case "U":
			if (ulast2char == "B" && ulastchar == "Y") return r2h.getString("byu");
			if (ulast2char == "C" && (ulastchar == "H" || ulastchar == "Y")) return r2h.getString("chu");
			if (ulast2char == "D" && ulastchar == "H") return r2h.getString("dhu");
			if (ulast2char == "D" && ulastchar == "Y") return r2h.getString("dyu");
			if (ulast2char == "F" && ulastchar == "Y") return r2h.getString("fyu");
			if (ulast2char == "G" && ulastchar == "Y") return r2h.getString("gyu");
			if (ulast2char == "H" && ulastchar == "Y") return r2h.getString("hyu");
			if (ulast2char == "J" && ulastchar == "Y") return r2h.getString("ju");
			if (ulast2char == "K" && ulastchar == "Y") return r2h.getString("kyu");
			if ((ulast2char == "L" || ulast2char == "X") && ulastchar == "Y") return r2h.getString("lyu");
			if ((ulast2char == "L" || ulast2char == "X") && ulastchar == "T") return ichi.getString("ltu");
			if (ulast2char == "M" && ulastchar == "Y") return r2h.getString("myu");
			if (ulast2char == "N" && ulastchar == "Y") return r2h.getString("nyu");
			if (ulast2char == "P" && ulastchar == "Y") return r2h.getString("pyu");
			if (ulast2char == "R" && ulastchar == "Y") return r2h.getString("ryu");
			if (ulast2char == "S" && (ulastchar == "H" || ulastchar == "Y")) return r2h.getString("shu");
			if (ulast2char == "T" && ulastchar == "H") return r2h.getString("thu");
			if (ulast2char == "T" && ulastchar == "S") return r2h.getString("tu");
			if (ulast2char == "T" && ulastchar == "Y") return r2h.getString("chu");
			if (ulast2char == "Z" && ulastchar == "Y") return r2h.getString("ju");
			if (ulastchar == "B") return last2char + r2h.getString("bu");
			if (ulastchar == "D") return last2char + r2h.getString("du");
			if (ulastchar == "F") return last2char + r2h.getString("fu");
			if (ulastchar == "G") return last2char + r2h.getString("gu");
			if (ulastchar == "H") return last2char + r2h.getString("fu");
			if (ulastchar == "J") return last2char + r2h.getString("ju");
			if (ulastchar == "K") return last2char + r2h.getString("ku");
			if (ulastchar == "L" || ulastchar == "X") return last2char + r2h.getString("lu");
			if (ulastchar == "M") return last2char + r2h.getString("mu");
			if (ulastchar == "N") return last2char + r2h.getString("nu");
			if (ulastchar == "P") return last2char + r2h.getString("pu");
			if (ulastchar == "R") return last2char + r2h.getString("ru");
			if (ulastchar == "S") return last2char + r2h.getString("su");
			if (ulastchar == "T") return last2char + r2h.getString("tu");
			if (ulastchar == "V") return last2char + r2h.getString("vu");
			if (ulastchar == "W") return last2char + r2h.getString("u");
			if (ulastchar == "Y") return last2char + r2h.getString("yu");
			if (ulastchar == "Z") return last2char + r2h.getString("zu");
			return last2char + lastchar + r2h.getString("u");
		case "E":
			if (ulast2char == "B" && ulastchar == "Y") return r2h.getString("bye");
			if (ulast2char == "C" && (ulastchar == "H" || ulastchar == "Y")) return r2h.getString("che");
			if (ulast2char == "D" && ulastchar == "H") return r2h.getString("dhe");
			if (ulast2char == "D" && ulastchar == "Y") return r2h.getString("dye");
			if (ulast2char == "F" && ulastchar == "Y") return r2h.getString("fe");
			if (ulast2char == "G" && ulastchar == "Y") return r2h.getString("gye");
			if (ulast2char == "H" && ulastchar == "Y") return r2h.getString("hye");
			if (ulast2char == "J" && ulastchar == "Y") return r2h.getString("je");
			if (ulast2char == "K" && ulastchar == "Y") return r2h.getString("kye");
			if ((ulast2char == "L" || ulast2char == "X") && ulastchar == "Y") return r2h.getString("lye");
			if (ulast2char == "M" && ulastchar == "Y") return r2h.getString("mye");
			if (ulast2char == "N" && ulastchar == "Y") return r2h.getString("nye");
			if (ulast2char == "P" && ulastchar == "Y") return r2h.getString("pye");
			if (ulast2char == "R" && ulastchar == "Y") return r2h.getString("lye");
			if (ulast2char == "S" && (ulastchar == "H" || ulastchar == "Y")) return r2h.getString("she");
			if (ulast2char == "T" && ulastchar == "H") return r2h.getString("the");
			if (ulast2char == "T" && ulastchar == "Y") return r2h.getString("tye");
			if (ulast2char == "W" && ulastchar == "Y") return r2h.getString("wye");
			if (ulast2char == "Z" && ulastchar == "Y") return r2h.getString("je");
			if (ulastchar == "B") return last2char + r2h.getString("be");
			if (ulastchar == "D") return last2char + r2h.getString("de");
			if (ulastchar == "F") return last2char + r2h.getString("fe");
			if (ulastchar == "G") return last2char + r2h.getString("ge");
			if (ulastchar == "H") return last2char + r2h.getString("he");
			if (ulastchar == "J") return last2char + r2h.getString("je");
			if (ulastchar == "K") return last2char + r2h.getString("ke");
			if (ulastchar == "L" || ulastchar == "X") return last2char + r2h.getString("lye");
			if (ulastchar == "M") return last2char + r2h.getString("me");
			if (ulastchar == "N") return last2char + r2h.getString("ne");
			if (ulastchar == "P") return last2char + r2h.getString("pe");
			if (ulastchar == "R") return last2char + r2h.getString("re");
			if (ulastchar == "S") return last2char + r2h.getString("se");
			if (ulastchar == "T") return last2char + r2h.getString("te");
			if (ulastchar == "V") return last2char + r2h.getString("ve");
			if (ulastchar == "W") return last2char + r2h.getString("we");
			if (ulastchar == "Y") return last2char + r2h.getString("ye");
			if (ulastchar == "Z") return last2char + r2h.getString("ze");
			return last2char + lastchar + r2h.getString("e");
		case "O":
			if (ulast2char == "B" && ulastchar == "Y") return r2h.getString("byo");
			if (ulast2char == "C" && (ulastchar == "H" || ulastchar == "Y")) return r2h.getString("cho");
			if (ulast2char == "D" && ulastchar == "H") return r2h.getString("dho");
			if (ulast2char == "D" && ulastchar == "Y") return r2h.getString("dyo");
			if (ulast2char == "F" && ulastchar == "Y") return r2h.getString("fyo");
			if (ulast2char == "G" && ulastchar == "Y") return r2h.getString("gyo");
			if (ulast2char == "H" && ulastchar == "Y") return r2h.getString("hyo");
			if (ulast2char == "J" && ulastchar == "Y") return r2h.getString("jyo");
			if (ulast2char == "K" && ulastchar == "Y") return r2h.getString("kyo");
			if ((ulast2char == "L" || ulast2char == "X") && ulastchar == "Y") return r2h.getString("lyo");
			if (ulast2char == "M" && ulastchar == "Y") return r2h.getString("myo");
			if (ulast2char == "N" && ulastchar == "Y") return r2h.getString("nyo");
			if (ulast2char == "P" && ulastchar == "Y") return r2h.getString("pyo");
			if (ulast2char == "R" && ulastchar == "Y") return r2h.getString("ryo");
			if (ulast2char == "S" && (ulastchar == "H" || ulastchar == "Y")) return r2h.getString("sho");
			if (ulast2char == "T" && ulastchar == "H") return r2h.getString("tho");
			if (ulast2char == "T" && ulastchar == "Y") return r2h.getString("tyo");
			if (ulast2char == "Z" && ulastchar == "Y") return r2h.getString("jo");
			if (ulastchar == "B") return last2char + r2h.getString("bo");
			if (ulastchar == "D") return last2char + r2h.getString("do");
			if (ulastchar == "F") return last2char + r2h.getString("fo");
			if (ulastchar == "G") return last2char + r2h.getString("go");
			if (ulastchar == "H") return last2char + r2h.getString("ho");
			if (ulastchar == "J") return last2char + r2h.getString("jo");
			if (ulastchar == "K") return last2char + r2h.getString("ko");
			if (ulastchar == "L" || ulastchar == "X") return last2char + r2h.getString("lo");
			if (ulastchar == "M") return last2char + r2h.getString("mo");
			if (ulastchar == "N") return last2char + r2h.getString("no");
			if (ulastchar == "P") return last2char + r2h.getString("po");
			if (ulastchar == "R") return last2char + r2h.getString("ro");
			if (ulastchar == "S") return last2char + r2h.getString("so");
			if (ulastchar == "T") return last2char + r2h.getString("to");
			if (ulastchar == "V") return last2char + r2h.getString("vo");
			if (ulastchar == "W") return last2char + r2h.getString("wo");
			if (ulastchar == "Y") return last2char + r2h.getString("yo");
			if (ulastchar == "Z") return last2char + r2h.getString("zo");
			return last2char + lastchar + r2h.getString("o");
	}
}
function isalpha(c) {
	return ((c >= "A" && c <= "Z") || (c >= "a" && c <= "z"));
}

function expand(str){//̊֐͌BubVAbvKvB
var r2h=document.getElementById("xmstrings");
var ichi=document.getElementById("xmstrings2");
	var child = str.charAt(str.length-1);
	var ret;
	switch(child){
		case "k":
		case "s":
		case "t":
		case "h":
		case "m":
		case "r":
		case "g":
		case "z":
		case "d":
		case "b":
		case "p":
		case "l":
		case "x":
			ret = str.substring(0,str.length-1)+
				"["+r2h.getString(child+"a")+
				r2h.getString(child+"i")+
				r2h.getString(child+"u")+
				r2h.getString(child+"e")+
				r2h.getString(child+"o")+
				ichi.getString("ltu")+
				"]";
		break;
		case "n":
			ret = str.substring(0,str.length-1)+
				"["+r2h.getString("na")+
				r2h.getString("ni")+
				r2h.getString("nu")+
				r2h.getString("ne")+
				r2h.getString("no")+
				ichi.getString("n")+
				"]";
		break;
		case "y":
			ret = str.substring(0,str.length-1)+
				"["+r2h.getString("ya")+
				r2h.getString("yu")+
				r2h.getString("yo")+
				"]";
		break;
		case "w":
			ret = str.substring(0,str.length-1)+
				"["+r2h.getString("wa")+
				r2h.getString("wo")+
				"]";
		break;
		case "j":
			ret = str.substring(0,str.length-1)+r2h.getString("ji");
		break;
		case "f":
			ret = str.substring(0,str.length-1)+r2h.getString("fu");
		break;
		case "v":
			ret = str.substring(0,str.length-1)+r2h.getString("vu");
		break;
		default:
			ret = str;
		break;
	}
	//alert("expand:"+ret);
	return ret;
	
}
