// ==UserScript==
// @name           GoogleAutoPager
// @namespace      http://ma.la/
// @author         ma.la <timpo@ma.la>
// @include        http://www.google.*/search*
// @description Add autoloading for next page to Google search result. DblClick to enable/disable it. Demo at http://la.ma.la/misc/demo/googleautopager.htm (Working in Trixie and captured by Wink)
// ==/UserScript==

// Released under the GPL license
//  http://www.gnu.org/copyleft/gpl.html

// ver 0.1 @ 2005-06-23
//  IɌJ
//  experimental release
// ver 0.2 @ 2005-06-23
//  _uNbNŃX^[gAɂĂ݂B
//  double click to start.

// ver 0.2.3.sylera @ 2007-04-10
//  Xe[^X\cĂ܂̂CB
// ver 0.2.2.sylera @ 2006-02-10
//  X^[gƃ_uNbNX^[gݒł悤ɂB
// ver 0.2.1.sylera @ 2006-01-30
//  Sylerapɉ

// -------------------------------------------------------------------
// ݒ --------------------------------------------------------------
// true:ŃX^[gBfalse:_uNbNŃX^[gB
var isStartAuto = true;
// -------------------------------------------------------------------

var syleraApi = Components.classes["@mozilla.org/sylera-api;1"].getService(Components.interfaces.nsISyleraAPI);
var targetWindow = syleraApi.getDOMWindow(syleraApiLayerIndex, syleraApiViewIndex);
var targetdocument = targetWindow.document;
var endFlag = 0;

try {
	var base = "http://"+targetWindow.location.host+"/search";
	var offset;
	var num;
	var query;
	var insertPoint;
	var Enable = -1;
	var watch_scroll = function() {
		if(endFlag == 1)
		{
			return;
		}
		try {
			var sc = targetdocument.body.scrollTop;
			var total = (targetdocument.body.scrollHeight - targetdocument.body.clientHeight);
			var remain = total - sc;
			if(remain < 500 && Enable == 1) {
				do_request();
			}
		}
		catch(e) {
		}
		var self = arguments.callee;
		targetWindow.setTimeout(self,100);
	};

	var do_request = function() {
		if(this.requested == offset) {return;}
		this.requested = offset;
		var xmlhttp;
		try {
			xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
		}
		catch(e) {
			xmlhttp = new targetWindow.XMLHttpRequest();
		}
		xmlhttp.onreadystatechange = function() {
			if(xmlhttp.readyState == 4) {
				window.status = "";
				var v = xmlhttp.responseText;
				if(v.indexOf("id=nn") == -1){
					endFlag = 1;
				}
				var start = v.indexOf("<div><div class=g>");
				var end = v.indexOf("<div id=navbar class=n>");
				if(start == -1 || end == -1) {
					return;
				}
				v = v.slice(start,end);
				var div = document.createElement("div");
				div.innerHTML = ["<hr>[Range]",offset," to ",(offset+num),"","<p class=g>",v].join("");
				var parentNode = insertPoint.parentNode;
				parentNode.insertBefore(div,insertPoint);
				offset += num;
			}
		};
		xmlhttp.open("GET", base+query.replace(/start=\d*/,"start="+offset), true);
		targetWindow.status = "loading ... " + offset +" - " + (offset+num);
		xmlhttp.send(null);
	};

	var init_autopager = function() {
		insertPoint = targetdocument.getElementById("navbar");
		if(!insertPoint) {
			return false;
		}

		var next = document.getElementById('nn');
		if(!next) {
			return false;
		}
		var href = next.parentNode.href;
		query = href.substr(href.indexOf("?"));
		offset = (query.match(/&+start=(\d*)/))[1] - 0;
		var tmp = query.match(/&+num=(\d*)/);
		num = tmp ? tmp[1]-0 : 10;
		return true;
	};

	// init
	if(init_autopager() != false) {
		if(isStartAuto == false) {
			if(targetdocument.body.attachEvent) {
				targetdocument.body.attachEvent(
					'ondblclick',function() {
						Enable *= -1;
						targetWindow.status = (Enable==1)?"Enabled":"Disabled";
					}
					);
			} else {
				targetdocument.body.addEventListener(
					'dblclick',function() {
						Enable *= -1;
						targetWindow.status = (Enable==1)?"Enabled":"Disabled";
					}, true
					);
			}
		} else {
			Enable *= -1;
			targetWindow.status = (Enable==1)?"Enabled":"Disabled";
		}
		watch_scroll();
	};
}
catch(e) {
	targetWindow.status = e;
}
