/**
 * Original source from
 * https://addons.mozilla.org/extensions/moreinfo.php?application=firefox&id=879
 */
var syleraApi = Components.classes['@mozilla.org/sylera-api;1'].getService(Components.interfaces.nsISyleraAPI);





execute();





function execute(){
	var id = prompt("ID͂ĉ");
	if(id == null) {
		return;
	}
	var topWin = syleraApi.getDOMWindow(-1, -1);
	if(topWin == NaN || topWin == null) {
		return;
	}
	execute2(id, topWin);
}

function execute2(id, topWin){
	//ThenFetch element
	var element = topWin.MLB_elementsWithId[id];
	MLB_doc = element.ownerDocument;
	MLB_currentWin = MLB_doc.defaultView;
	//Return code for onclick-functions
	var returnCode = true;
	var tagName = element.tagName.toLowerCase();
	var type = element.type?element.type.toLowerCase():null;

	if(tagName=="body"){
		MLB_doc.defaultView.focus();
		return;
	}
	//If it is text- or password-field
	if((tagName=="input" && (type=="text" || type=="password")) ||
	   tagName=="textarea"){
		element.select();
	}
	//If its an anchor and it should be openend in a new Tab
	else if(tagName=="a" && MLB_openInNewTabFlag){
		syleraApi.insertView(element.href, Components.interfaces.nsISyleraAPI.ViewTypeGecko, -1, -1);
		return;
	}
	//In every other case try to focus
	else {
		try{
			element.focus();
		}catch(e){}
	}
}
