goMimePrefs();

function goMimePrefs() {
   /* openDialog("chrome://mtypes/content/pref/pref.xul",
              "PrefWindow", 
              "chrome,titlebar,resizable=yes", 
              "chrome://mtypes/content/pref/pref-applications.xul", 
              "browser", 
              "appPanel"); */
              
   goMozPrefs("chrome://mtypes/content/pref/pref-applications.xul", "appPanel", "browser");
}

function goMozPrefs(paneURL, itemID, containerID)
{
   var resizable;
   var pref = Components.classes["@mozilla.org/preferences-service;1"]
                        .getService(Components.interfaces.nsIPrefBranch);
   try {
      // We are resizable ONLY if in box debugging mode, because in
      // this special debug mode it is often impossible to see the 
      // content of the debug panel in order to disable debug mode.
      resizable = pref.getBoolPref("xul.debug.box");
   }
   catch (e) {
      resizable = false;
   }
   
   //check for an existing pref window and focus it; it's not application modal
   /* const kWindowMediatorContractID = "@mozilla.org/appshell/window-mediator;1";
   const kWindowMediatorIID = Components.interfaces.nsIWindowMediator;
   const kWindowMediator = Components.classes[kWindowMediatorContractID].getService(kWindowMediatorIID);
   var lastPrefWindow = kWindowMediator.getMostRecentWindow("mozilla:preferences");
   if (lastPrefWindow)
      lastPrefWindow.focus();
   else { */
      var resizability = resizable ? "yes" : "no";
      var features = "chrome,titlebar,resizable=" + resizability;
      openDialog("chrome://mtypes/content/pref/pref.xul","PrefWindow", 
                 features, paneURL, itemID, containerID);
   // }
}
