saveBackgroundImage();
function saveBackgroundImage() {
	var syleraApi = Components.classes["@mozilla.org/sylera-api;1"].getService(Components.interfaces.nsISyleraAPI);

	if(syleraApi.getViewType(-1, -1) == Components.interfaces.nsISyleraAPI.ViewTypeIE) {
		alert('IEr[ł͎gpł܂');
		return;
	}


	var layerIndex = syleraApi.getSelectedLayerIndex();
	var viewIndex = syleraApi.getSelectedViewIndex(layerIndex);
	var domWnd = syleraApi.getDOMWindow(layerIndex, viewIndex);
	if(domWnd == null) {
		alert('DOMWindow擾ł܂');
		return;
	}

	// pages with multiple <body>s are lame. we'll teach them a lesson.
	var bodyElt = domWnd.document.getElementsByTagName("body")[0];
	if(!bodyElt) {
		alert('body^O܂');
		return;
	}

	var computedURL = getComputedURL(bodyElt, "background-image");
	if(!computedURL) {
		alert('wi摜URL擾ł܂');
		return;
	}

	bgImageURL = makeURLAbsolute(bodyElt.baseURI, computedURL);


	var targetFile = getSaveFile(bgImageURL.path.match(/[^\/]+$/));
	if(targetFile == null) {
		return;
	}


	var postData = null;
	try{
		var SH = getWebNavigation().sessionHistory;
		var entry = SH.getEntryAtIndex(SH.index, false).QueryInterface(Components.interfaces.nsISHEntry);
		postData = entry.postData;
	}
	catch(e) {
	}


	var persist = Components.classes['@mozilla.org/embedding/browser/nsWebBrowserPersist;1'].createInstance(Components.interfaces.nsIWebBrowserPersist);
	try{
		persist.saveURI(bgImageURL, null, null, postData, null, targetFile);
	}
	catch(e) {
		alert('ۑł܂B');
	}
}



function getComputedURL(elem, prop) {
	var url = elem.ownerDocument.defaultView.getComputedStyle( elem, '' ).getPropertyCSSValue( prop );
	return (url.primitiveType == CSSPrimitiveValue.CSS_URI) ? url.getStringValue() : null;
}



function makeURLAbsolute(base, url) {
	// Construct nsIURL.
	var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var baseURI = ioService.newURI(base, null, null);

	return ioService.newURI(baseURI.resolve(url), null, null);
}



function getSaveFile(defaultFileName)
{
	const nsIFilePicker = Components.interfaces.nsIFilePicker;
	const filePicker = Components.classes['@mozilla.org/filepicker;1'].createInstance(nsIFilePicker);

	filePicker.init(window, "ۑ", nsIFilePicker.modeSave);

	// ftHg̃t@C
	filePicker.defaultString = defaultFileName;

	// ۑ`̓o^
	filePicker.appendFilters(nsIFilePicker.filterImages);

	if(filePicker.show() == nsIFilePicker.returnCancel)
	{
		return null;
	}

	return filePicker.file;
}
